<?php
/**
 * TeknisaAbstractRegra.
 *
 * @package Logic
 * @author  alessandrobartels / brunofeliciano 12/08/2011
 *
 */
abstract class TeknisaAbstractRegra {

    private $_evaluator;


    /**
     * Construtor.
     *
     * @param TkEvaluator $evaluator Instancia de TkEvaluator.
     */
    public function __construct(TkEvaluator $evaluator) {
        $this->_evaluator = $evaluator;
    }


    /**
     * Declara as variaveis utilizadas nas regras.
     *
     * @param string $nome  Nome da variavel.
     * @param string $valor Valor da variavel.
     *
     * @return void
     *
     * @author  alessandrobartels / brunofeliciano 12/08/2011
     */
    public function setVar($nome, $valor){
        $this->_evaluator->setVar($nome, $valor);
    }


    /**
     * Executa Regra.
     *
     * @param string  $code  Codigo de execucao da regra.
     * @param boolean $debug Flag para exibir o debug.
     *
     * @return mixed
     *
     * @author  alessandrobartels / brunofeliciano 12/08/2011
     */
    public function executaRegra($code, $debug = false){
        $valor = $this->_evaluator->evaluate($code, $debug);
        return $valor;
    }


}