/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ENCA                                                     */
/* Tabela : ENCARGO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ENCA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ENCA
GO

CREATE TRIGGER DTULTATU_ENCA
ON ENCARGO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ENCARGO', null, 'CDENCARGO=' + CDENCARGO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ENCARGO
      SET DTULTATUENCA = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ENCARGO.CDENCARGO,0) = ISNULL(INSERTED.CDENCARGO,0)) AND
            (ISNULL(ENCARGO.NMENCARGO,0) = ISNULL(INSERTED.NMENCARGO,0)) AND
            (ISNULL(ENCARGO.IDENCARGO,0) = ISNULL(INSERTED.IDENCARGO,0));
   END;
END;
GO

