import {
  Loader, Http, Metadata, IDictionary, IEventParam, Config,
} from '@zeedhi/core';

import {
  Form, LoadingService, List, Select, Tabs, GridEditable, Checkbox,
} from '@zeedhi/common';
import { PmeMask } from '@/config';
  
export class Pla01900ParametrosPlanejamentoController {
  // Utils
  
  private utilities = Loader.getInstance('Utilities');
  
  public appController = Loader.getInstance('AppController');

  public gridEditController = Loader.getInstance('GridEditableController');
  
  public crudController = Loader.getInstance('CrudController');
  
  // Flags
  
  public disabledButtonsGeral = true;
  
  public disabledButtonsPlaneja = true;
  
  public disabledButtonsGrupOper = true;
  
  // Parâmetros da paramgeral
  
  private idblopratloc = true;
  
  private idbloqpradup = false;
  
  private qtDiaBloqCar = '';
  
  private cdcabohidra = '';
  
  private cdproteina = '';
  
  private cdalcool = '';
  
  private cdlipidios = '';
  
  private cdcalorias = '';
  
  private cdacidgraxos = '';
  
  private cdacucares = '';
  
  private idutrpadca = false;
  
  private paramGeralDict = {};
  
  // Parâmetros da paramplaneja e filial
  
  private filialFilterValue = '';
  
  private idcardiautil = '';
  
  private idconsgrprat = '';
  
  private idservincfilagr = '';
  
  private idcuspadcar = '';
  
  private cdservretpme = '';
  
  private cdnutrrelat1 = '';
  
  private cdnutrrelat2 = '';
  
  private cdnutrrelat3 = '';
  
  private cdnutrrelat4 = '';
  
  private idprinvenreti = '';
  
  private cdtpretipadr = '';
  
  private cdtipocustorea = '';
  
  private cdtipocustopla = '';
  
  private idexibecusto = '';
  
  private idperccome = '';
  
  private txmenscardia = '';
  
  private txmenscarsem = '';
  
  private cdtcaconsper = '';
  
  private cdtcaconsfix = '';
  
  private nrcorcardesp: any = '';
  
  private nrcornutil: any = '';
  
  private nrcornalte: any = '';
  
  private nrcorsafra: any = '';
  
  private nrcorinicsaf: any = '';
  
  private nrcorentrsaf: any = '';
  
  private idcomcusperc = '';
  
  private paramPlanejaDict = {};
  
  private idutretbaseinve = '';
  
  private idautperfacesso = '';
  
  private paramGrupOper = {};
  
  private fieldByParam = {
    ALTRECEPADRAO: {
      label: 'Autorização de Alterações em Receitas Padrões',
      nameField: 'DSGROPERREPA',
      value: 'CDGROPERREPA',
    },
  };
  
  // Form

  public submitFunc() {
    const tabPrincipal: Tabs = Metadata.getInstance('principalTabParametros');
    const activeTab = tabPrincipal.activeTab;
    const tabCard: Tabs = Metadata.getInstance('subTabGeral');

    if (tabCard.activeTab === 0) {
      if (activeTab === 0) this.submitParametrosPlanGeralCard();
      else this.submitParametrosPlaneja();
    }
  }

  public returnActiveTab() {
    if (document.getElementsByName('subTabParametros').length > 0) {
      const subTabPlaneja: Tabs = Metadata.getInstance('subTabParametros');
      const activeSubTab = subTabPlaneja.activeTab;
      const arrayHelper = ['Planejamento', 'Elaboracao', 'MensCard', 'ReqRetirada', 'SafraCard', 'calculoNDPCAL'];
      const nameActive = arrayHelper[activeSubTab];
      
      return nameActive;
    }
    return undefined;
  }
  
  public visibleParam() {
    if (document.getElementsByName('CDFILIAL').length > 0 && document.getElementsByName('IDUTRETBASEINVE').length > 0) {
      const cdfilial = Metadata.getInstance<Select>('CDFILIAL');
      const idut = Metadata.getInstance<Checkbox>('IDUTRETBASEINVE');
      // IDFILCENTPME == CDFILIAL && IDTPFILIALCENT == 'M'
      idut.isVisible = true;
      if (cdfilial.selectValue.IDFILCENTPME === 'S' && cdfilial.selectValue.IDTPFILIALCENT === 'M') {
        idut.disabled = false;
      } else {
        idut.disabled = true;
        if (cdfilial.selectValue.CENTRAL) {
          this.utilities.getParamFilial(cdfilial.selectValue.CENTRAL).then((paramfilial: IDictionary) => {
            if (paramfilial.IDUTRETBASEINVE === 'S') idut.value = 'S';
            else idut.value = 'N';
          });
        } else idut.value = 'N';
      }
      this.controlIdPrin();
    }
  }
  
  public controlIdPrin() {
    if (document.getElementsByName('IDPRINVENRETI').length > 0 && document.getElementsByName('IDUTRETBASEINVE').length > 0) {
      const idprin = Metadata.getInstance<Checkbox>('IDPRINVENRETI');
      const idut = Metadata.getInstance<Checkbox>('IDUTRETBASEINVE');
      if (idut.value === 'S') idprin.disabled = false;
      else idprin.disabled = true;
    }
  }
  
  public cancelFunc() {
    const tabPrincipal: Tabs = Metadata.getInstance('principalTabParametros');
    const activeTab = tabPrincipal.activeTab;
    
    if (activeTab === 0) this.cancelFormGeral();
    else this.cancelFormPlaneja();
  }
  
  public reloadParamGeral() {
    this.getParamGeral();
  }
  
  public reloadParamPlaneja() {
    this.getParamPlanejaEFilial();
  }
  
  public reloadGrupOper() {
    this.getParamGrupOper();
  }
  
  public cancelForm() {
    this.disabledButtonsGeral = true;
    this.disabledButtonsPlaneja = true;
  }
  
  public cancelFormGeral() {
    this.disabledButtonsGeral = true;
    this.reloadParamGeral();
    this.closeListGroup('groupListCardapio');
    this.openListGroup('groupListCardapio');
  }
  
  public cancelFormPlaneja({ component }: IDictionary = []) {
    const tabName = component ? component.name.substr(12) : this.returnActiveTab();
    
    this.disabledButtonsPlaneja = true;
    this.closeListGroup(`groupList${tabName}`);
    this.openListGroup(`groupList${tabName}`);
    this.reloadParamPlaneja();
  }
  
  public cancelFormGrupOper() {
    this.disabledButtonsGrupOper = true;
    this.reloadGrupOper();
  }
  
  public changeFieldGeral() {
    this.disabledButtonsGeral = false;
  }
  
  public changeFieldPlaneja() {
    if (this.filialFilterValue) this.disabledButtonsPlaneja = false;
    else Metadata.getInstance<Form>('formUnidade').validate();
  }
  
  public changeFieldGrupOper() {
    this.disabledButtonsGrupOper = false;
  }
  
  private callLoading() {
    LoadingService.show(' ');
    window.setTimeout(() => LoadingService.hide(), 1000);
    window.setTimeout(() => this.utilities.showAlert('alert', 'pme::salvoComSucesso', 'success'), 1100);
  }
  
  private closeListGroup(nameComponent: string) {
    const listElement: List = Metadata?.getInstance(nameComponent);
    
    if (listElement) listElement.childrenInstances.forEach((ele) => { ele.opened = false; });
  }
  
  private openListGroup(nameComponent: string) {
    const listElement: List = Metadata?.getInstance(nameComponent);
    
    if (listElement) listElement.childrenInstances.forEach((ele) => { ele.opened = true; });
  }
  
  // Filters
  
  public setFilterFilial({ component }: IEventParam<Select>) {
    const filter = [
      {
        name: 'CDFILCENTPME',
        operator: '=',
        value: this.filialFilterValue,
      },
    ];
    
    component.datasource.filter = filter;
    component.datasource.get();
  }
  
  public setFilterServicoRet({ component }: IEventParam<Select>) {
    const filter = [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: this.filialFilterValue,
      },
    ];
    
    component.datasource.filter = filter;
    component.datasource.get();
  }
  
  public setFilialLogada({ component }: IDictionary) {
    component.value = localStorage.getItem('CDFILIALLOGADA');
  }
  
  // Getters
  
  public async getParamGeral() {
    let data;
    let paramgeral = await Http.get('/paramgeral');
    if (paramgeral.data.data.length === 0) {
      paramgeral = await Http.get('/insereParamgeral', {});
      data = paramgeral.data.dataset.data;
    } else {
      data = paramgeral.data.data[0];
    }
    
    this.qtDiaBloqCar = data.QTDIABLOQCAR;
    this.cdcabohidra = data.CDCARBOHIDRA;
    this.cdproteina = data.CDPROTEINA;
    this.cdalcool = data.CDALCOOL;
    this.cdlipidios = data.CDLIPIDIOS;
    this.cdcalorias = data.CDCALORIAS;
    this.cdacidgraxos = data.CDACIDGRAXOS;
    this.cdacucares = data.CDACUCARES;
    this.idutrpadca = data.IDUTRPADCA;
    this.idblopratloc = data.IDBLOPRATLOC;
    this.idbloqpradup = data.IDBLOQPRADUP;
  }
  
  public getParamPlanejaEFilial() {
    this.utilities.getParamPlaneja(this.filialFilterValue).then((paramplaneja: IDictionary) => {
      this.idblopratloc = paramplaneja?.IDBLOPRATLOC;
      this.idbloqpradup = paramplaneja?.IDBLOQPRADUP;
      this.idcardiautil = paramplaneja?.IDCARDIAUTIL;
      this.idconsgrprat = paramplaneja?.IDCONSGRPRAT;
      this.idservincfilagr = paramplaneja?.IDSERVINCFILAGR;
      this.idcuspadcar = paramplaneja?.IDCUSPADCAR;
      this.cdservretpme = paramplaneja?.CDSERVRETPME;
      this.cdnutrrelat1 = paramplaneja?.CDNUTRRELAT1;
      this.cdnutrrelat2 = paramplaneja?.CDNUTRRELAT2;
      this.cdnutrrelat3 = paramplaneja?.CDNUTRRELAT3;
      this.cdnutrrelat4 = paramplaneja?.CDNUTRRELAT4;
      this.idprinvenreti = paramplaneja?.IDPRINVENRETI;
      this.cdtpretipadr = paramplaneja?.CDTPRETIPADR;
      this.cdtipocustopla = paramplaneja?.CDTIPOCUSTOPLA;
      this.cdtipocustorea = paramplaneja?.CDTIPOCUSTOREA;
      this.idexibecusto = paramplaneja?.IDEXIBECUSTO;
      this.idperccome = paramplaneja?.IDPERCCOME;
      this.txmenscardia = paramplaneja?.TXMENSCARDIA;
      this.txmenscarsem = paramplaneja?.TXMENSCARSEM;
      this.cdtcaconsper = paramplaneja?.CDTCACONSPER;
      this.cdtcaconsfix = paramplaneja?.CDTCACONSFIX;
      this.nrcorcardesp = this.utilities.TColorToHex(paramplaneja?.NRCORCARDESP);
      this.nrcornutil = this.utilities.TColorToHex(paramplaneja?.NRCORNUTIL);
      this.nrcornalte = this.utilities.TColorToHex(paramplaneja?.NRCORNALTE);
      this.nrcorsafra = this.utilities.TColorToHex(paramplaneja?.NRCORSAFRA);
      this.nrcorinicsaf = this.utilities.TColorToHex(paramplaneja?.NRCORINICSAF);
      this.nrcorentrsaf = this.utilities.TColorToHex(paramplaneja?.NRCORENTRSAF);
    });
    
    this.utilities.getParamFilial(this.filialFilterValue).then((paramfilial: IDictionary) => {
      this.idcomcusperc = paramfilial?.IDCOMCUSPERC;
      this.idutretbaseinve = paramfilial?.IDUTRETBASEINVE;
    });
    
    this.visibleParam();
    
    const activeTab = this.returnActiveTab();
    if (activeTab) this.openListGroup(`groupList${activeTab}`);
  }
  
  public getParamGrupOper() {
    Http.get('/autperfilacesso').then((perfilacesso) => {
      if (Array.isArray(perfilacesso.data.data) && perfilacesso.data.data.length) {
        const arrayPerfil = perfilacesso.data.data;
        arrayPerfil.forEach((item: any) => {
          if (item.IDAUTPERFACESSO === 'ALTRECEPADRAO') {
            this.idautperfacesso = item.NRPERFILACESSO;
            // this.idautperfacesso = perfilacesso.data.data[0]?.NRPERFILACESSO;
          }
        });
      }
    });
    this.disabledButtonsPlaneja = true;
  }
  
  // Submits
  
  public submitParametrosPlanGeralCard() {
    const formGeralCard = Metadata.getInstance<Form>('formTabCardapio');
    
    if (formGeralCard.validate()) {
      this.paramGeralDict = {
        QTDIABLOQCAR: this.qtDiaBloqCar,
        CDCARBOHIDRA: this.cdcabohidra,
        CDPROTEINA: this.cdproteina,
        CDALCOOL: this.cdalcool,
        CDLIPIDIOS: this.cdlipidios,
        CDCALORIAS: this.cdcalorias,
        CDACIDGRAXOS: this.cdacidgraxos,
        CDACUCARES: this.cdacucares,
        IDUTRPADCA: this.idutrpadca,
        IDBLOPRATLOC: this.idblopratloc,
        IDBLOQPRADUP: this.idbloqpradup,
      };
      
      this.callPlanGeralSave(this.paramGeralDict);
    }
  }
  
  public submitParametrosPlaneja({ component }: IDictionary = []) {
    const formFilterUnidade = Metadata.getInstance<Form>('formUnidade');
    const tabName = component ? component.name : this.returnActiveTab();
    
    if (formFilterUnidade.validate()) {
      this.fillParamPlanejaDict(tabName);
      this.callPlanejaSave(this.paramPlanejaDict);
    }
  }
  
  public submitParametrosGrupOper() {
    const formGrupOper = Metadata.getInstance<Form>('formTabGruoOper');
    const unidade = Metadata.getInstance<Select>('IDAUTPERFACESSO');
    
    if (formGrupOper.validate()) {
      this.paramGrupOper = {
        permissions: this.fieldByParam,
        currentRow: unidade.value,
      };
      
      this.callPlanGrupOperSave(this.paramGrupOper);
    }
  }
  
  // Call save
  
  private callPlanGeralSave(row: IDictionary) {
    Http.post('/updateParamGeral', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.cancelFormGeral();
      this.cancelForm();
      this.openListGroup('groupListCardapio');
    });
  }
  
  private callPlanejaSave(row: IDictionary) {
    Http.post('/updateParamPlaneja', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.closeListGroup(`groupList${row.tab}`);
      this.disabledButtonsPlaneja = true;
      this.openListGroup(`groupList${row.tab}`);
    });
  }
  
  private callPlanGrupOperSave(row: IDictionary) {
    Http.post('/updateGrupOper', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.cancelFormGrupOper();
      this.cancelForm();
    });
  }

  // Helpers
  
  private fillParamPlanejaDict(tabName: string) {
    if (tabName.includes('MensCard')) {
      this.paramPlanejaDict = {
        TXMENSCARSEM: this.txmenscarsem,
        TXMENSCARDIA: this.txmenscardia,
        CDFILIAL: this.filialFilterValue,
        tab: 'MensCard',
      };
    } else if (tabName.includes('ReqRetirada')) {
      this.paramPlanejaDict = {
        CDTCACONSPER: this.cdtcaconsper,
        CDTCACONSFIX: this.cdtcaconsfix,
        CDFILIAL: this.filialFilterValue,
        tab: 'ReqRetirada',
      };
    } else if (tabName.includes('Elaboracao')) {
      this.paramPlanejaDict = {
        CDTIPOCUSTOPLA: this.cdtipocustopla,
        CDTIPOCUSTOREA: this.cdtipocustorea,
        IDEXIBECUSTO: this.idexibecusto,
        IDPERCCOME: this.idperccome,
        CDFILIAL: this.filialFilterValue,
        tab: 'Elaboracao',
      };
    } else if (tabName.includes('Planejamento')) {
      this.paramPlanejaDict = {
        IDCARDIAUTIL: this.idcardiautil,
        IDCONSGRPRAT: this.idconsgrprat,
        IDSERVINCFILAGR: this.idservincfilagr,
        IDCUSPADCAR: this.idcuspadcar,
        IDCOMCUSPERC: this.idcomcusperc,
        CDSERVRETPME: this.cdservretpme,
        CDNUTRRELAT1: this.cdnutrrelat1,
        CDNUTRRELAT2: this.cdnutrrelat2,
        CDNUTRRELAT3: this.cdnutrrelat3,
        CDNUTRRELAT4: this.cdnutrrelat4,
        IDPRINVENRETI: this.idprinvenreti,
        CDTPRETIPADR: this.cdtpretipadr,
        CDFILIAL: this.filialFilterValue,
        IDUTRETBASEINVE: this.idutretbaseinve,
        tab: 'Planejamento',
      };
    } else if (tabName.includes('SafraCard')) {
      const nrcorcardesp = this.utilities.hexToRgbInline(this.nrcorcardesp).split('.', 3);
      const nrcornutil = this.utilities.hexToRgbInline(this.nrcornutil).split('.', 3);
      const nrcornalte = this.utilities.hexToRgbInline(this.nrcornalte).split('.', 3);
      const nrcorsafra = this.utilities.hexToRgbInline(this.nrcorsafra).split('.', 3);
      const nrcorinicsaf = this.utilities.hexToRgbInline(this.nrcorinicsaf).split('.', 3);
      const nrcorentrsaf = this.utilities.hexToRgbInline(this.nrcorentrsaf).split('.', 3);
      this.paramPlanejaDict = {
        NRCORCARDESP: this.utilities.RGBToTColor(nrcorcardesp[0], nrcorcardesp[1], nrcorcardesp[2]),
        NRCORNUTIL: this.utilities.RGBToTColor(nrcornutil[0], nrcornutil[1], nrcornutil[2]),
        NRCORNALTE: this.utilities.RGBToTColor(nrcornalte[0], nrcornalte[1], nrcornalte[2]),
        NRCORSAFRA: this.utilities.RGBToTColor(nrcorsafra[0], nrcorsafra[1], nrcorsafra[2]),
        NRCORINICSAF: this.utilities.RGBToTColor(nrcorinicsaf[0], nrcorinicsaf[1], nrcorinicsaf[2]),
        NRCORENTRSAF: this.utilities.RGBToTColor(nrcorentrsaf[0], nrcorentrsaf[1], nrcorentrsaf[2]),
        CDFILIAL: this.filialFilterValue,
        tab: 'SafraCard',
      };
    }
  }

  public saveCalcNDPCAL() {
    const form = Metadata.getInstance<Form>('formTabPlanejamentoCalcNDPCAL');
    const grid = Metadata.getInstance<GridEditable>('gridCalcNDPCAL');
    const editedRows: IDictionary = grid.getEditedRows();

    if (form.validate()) {
      if (editedRows.length > 0) {
        if (grid) grid.datasource.loading = true;
        Http.post('/saveNDPCAL', { requestType: 'Row', editedRows }).then((response) => {
          const result = response.data.dataset.saveConfigCard.type;
          if (result !== 'error') {
            this.gridEditController.defaultState(grid);
            grid.datasource.get();
            this.utilities.showAlert('Alert', 'pme::salvoComSucesso', 'success');
          } else this.utilities.showAlert('alert', 'pme::produtoExistente', 'error');
        }).catch((error: string) => {
          this.utilities.showAlert('alert', `pme::${error}`, 'error');
        }).finally(() => {
          if (grid) grid.datasource.loading = false;
        });
      }
    }
  }
  
  public produtoComponentProps = {
    component: 'ZdSelect',
    dataText: [
      {
        name: 'CDARVPROD',
        mask: (Config.masks.productMask as PmeMask).pattern,
      },
      'NMPRODUTO',
    ],
    formatterDataText: [
      {
        name: 'CDARVPROD',
        mask: (Config.masks.productMask as PmeMask).pattern,
      },
      'NMPRODUTO',
    ],
    dataValue: 'CDPRODUTO',
    dense: true,
    datasource: {
      uniqueKey: 'CDPRODUTO',
      route: '/find/productList',
      type: 'rest',
      limit: 10,
      lazyLoad: true,
    },
    returnObject: true,
    validations: {
      required: {
        message: 'pme::campoObrigatorio',
      },
    },
  };
}
